> For the complete documentation index, see [llms.txt](https://www.opal-rt.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://www.opal-rt.com/docs/hypersim/automation-api-and-scripting/python-dashboard-api/api-reference/class-reference/level.md).

# Level

*class* opalone.\_internal.levels.Level(*level\_id*, *model\_id*)

<table data-header-hidden><thead><tr><th width="158.22222900390625"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>A level is a component of a Model gathering other levels and Blocks. A level is created/deleted when a <em>subsystem</em> block is created/deleted.</td></tr><tr><td><strong>Parameters</strong></td><td><p><strong>level_id</strong> (<em>str</em>) – The ID of the level.</p><p><strong>model_id</strong> (<em>str</em>) – The ID of the model that owns this level.</p></td></tr><tr><td><strong>Bases</strong></td><td>Ressource</td></tr></tbody></table>

## Method

### add\_block

*add\_block(library\_block\_path)*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Add a single block to the top level</td></tr><tr><td><strong>Parameters</strong></td><td><strong>library_block_path</strong> (<em>str</em>) – The path of the block in a library.</td></tr><tr><td><strong>Returns</strong></td><td>The added block.</td></tr><tr><td><strong>Return type</strong></td><td>Block</td></tr></tbody></table>

### add\_multiple\_blocks

add\_multiple\_blocks(*library\_block\_paths*)

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Add multiple blocks to the level.</td></tr><tr><td><strong>Parameters</strong></td><td><strong>library_block_path</strong> (<em>str</em>) – The path of the block in a library.</td></tr><tr><td><strong>Returns</strong></td><td>The added blocks.</td></tr><tr><td><strong>Return type</strong></td><td>list[Block]</td></tr></tbody></table>

### delete

delete()

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Delete the current resource, which is done by suppressing its ID.</td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr><tr><td><strong>Returns</strong></td><td>None</td></tr></tbody></table>

### remove

remove(*blocks*)

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Remove one or more blocks from a level.</td></tr><tr><td><strong>Parameters</strong></td><td><strong>blocks</strong> (<em>str | Block | list[str|Block]</em>) – The blocks to remove from the level, either IDs or block objects. If a list is provided, IDs and objects can be mixed.</td></tr><tr><td><strong>Returns</strong></td><td>None</td></tr></tbody></table>

### to\_json

to\_json(*fields*, *values*)

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td>Convert this resource to a serialized JSON representation.</td></tr><tr><td><strong>Parameters</strong></td><td><ul><li><strong>fields</strong> (<em>tuple[str] | list[str]</em>) – Fields to include.</li><li><strong>values</strong> (<em>tuple[object] | list[object]</em>) – The value of each field</li></ul></td></tr><tr><td><strong>Returns</strong></td><td>The serialized JSON representation.</td></tr><tr><td><strong>Return type</strong></td><td>str</td></tr></tbody></table>

## Property

### blocks

*property* block&#x73;*: dict\[str, Block]*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td><p>The list of blocks in the level, as a mapping <em>name = block</em>. The block names are unique within a level.</p><p>This property is read-only, it cannot be modified. However, each block might have alterable properties.</p></td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr></tbody></table>

### id

*property* i&#x64;*: str*

<table data-header-hidden><thead><tr><th width="200"></th><th></th></tr></thead><tbody><tr><td><strong>Description</strong></td><td><p>The ID of the resource.</p><p>This property is read-only, it cannot be modified.</p></td></tr><tr><td><strong>Parameters</strong></td><td>None</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://www.opal-rt.com/docs/hypersim/automation-api-and-scripting/python-dashboard-api/api-reference/class-reference/level.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
